# OpenAPI\Client\AiApi

| Method | HTTP request | Description |
| ------------- | ------------- | ------------- |
| [**chat()**](AiApi.md#chat) | **POST** /v1/ai/chat | 元梦ai-对话 |
| [**extractContent()**](AiApi.md#extractContent) | **POST** /v1/ai/extractContent | 元梦ai-提取上传文件的内容 |
| [**speakerList()**](AiApi.md#speakerList) | **POST** /v1/ai/speakerList | 元梦ai-获取发音人列表 |
| [**tokenCount()**](AiApi.md#tokenCount) | **POST** /v1/ai/tokenCount | 元梦ai-token统计 |
| [**voiceClone()**](AiApi.md#voiceClone) | **POST** /v1/ai/voiceClone | 元梦ai-语音克隆 |


## `chat()`

```php
chat($chat_param): \OpenAPI\Client\Model\ResponseOpenAPIChatResult
```

元梦ai-对话

元梦ai对话

### 示例

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');



$apiInstance = new OpenAPI\Client\Api\AiApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$chat_param = new \OpenAPI\Client\Model\ChatParam(); // \OpenAPI\Client\Model\ChatParam

try {
    $result = $apiInstance->chat($chat_param);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling AiApi->chat: ', $e->getMessage(), PHP_EOL;
}
```

### 参数

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **chat_param** | [**\OpenAPI\Client\Model\ChatParam**](../Model/ChatParam.md)|  | [optional] |

### 返回类型

[**\OpenAPI\Client\Model\ResponseOpenAPIChatResult**](../Model/ResponseOpenAPIChatResult.md)

### HTTP请求头

- **Content-Type**: `application/json`
- **Accept**: `*/*`

[[回到顶部]](#) [[返回API列表]](../../README.md#api端点文档)
[[返回模型列表]](../../README.md#模型文档)
[[返回README]](../../README.md)

## `extractContent()`

```php
extractContent($file, $param): \OpenAPI\Client\Model\ResponseOpenAPIExtractContentResult
```

元梦ai-提取上传文件的内容

提取上传文件的内容

### 示例

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');



$apiInstance = new OpenAPI\Client\Api\AiApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$file = "/path/to/file.txt"; // \SplFileObject
$param = new \OpenAPI\Client\Model\ExtraContentParam(); // \OpenAPI\Client\Model\ExtraContentParam

try {
    $result = $apiInstance->extractContent($file, $param);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling AiApi->extractContent: ', $e->getMessage(), PHP_EOL;
}
```

### 参数

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **file** | **\SplFileObject****\SplFileObject**|  | [optional] |
| **param** | [**\OpenAPI\Client\Model\ExtraContentParam**](../Model/ExtraContentParam.md)|  | [optional] |

### 返回类型

[**\OpenAPI\Client\Model\ResponseOpenAPIExtractContentResult**](../Model/ResponseOpenAPIExtractContentResult.md)

### HTTP请求头

- **Content-Type**: `multipart/form-data`
- **Accept**: `*/*`

[[回到顶部]](#) [[返回API列表]](../../README.md#api端点文档)
[[返回模型列表]](../../README.md#模型文档)
[[返回README]](../../README.md)

## `speakerList()`

```php
speakerList(): \OpenAPI\Client\Model\ResponseOpenAPISpeakerListResult
```

元梦ai-获取发音人列表

获取发音人列表

### 示例

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');



$apiInstance = new OpenAPI\Client\Api\AiApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);

try {
    $result = $apiInstance->speakerList();
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling AiApi->speakerList: ', $e->getMessage(), PHP_EOL;
}
```

### 参数

该端点不需要任何参数.

### 返回类型

[**\OpenAPI\Client\Model\ResponseOpenAPISpeakerListResult**](../Model/ResponseOpenAPISpeakerListResult.md)

### HTTP请求头

- **Content-Type**: Not defined
- **Accept**: `*/*`

[[回到顶部]](#) [[返回API列表]](../../README.md#api端点文档)
[[返回模型列表]](../../README.md#模型文档)
[[返回README]](../../README.md)

## `tokenCount()`

```php
tokenCount($token_count_param): \OpenAPI\Client\Model\ResponseOpenAPITokensCountResult
```

元梦ai-token统计

元梦ai,token统计

### 示例

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');



$apiInstance = new OpenAPI\Client\Api\AiApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$token_count_param = new \OpenAPI\Client\Model\TokenCountParam(); // \OpenAPI\Client\Model\TokenCountParam

try {
    $result = $apiInstance->tokenCount($token_count_param);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling AiApi->tokenCount: ', $e->getMessage(), PHP_EOL;
}
```

### 参数

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **token_count_param** | [**\OpenAPI\Client\Model\TokenCountParam**](../Model/TokenCountParam.md)|  | [optional] |

### 返回类型

[**\OpenAPI\Client\Model\ResponseOpenAPITokensCountResult**](../Model/ResponseOpenAPITokensCountResult.md)

### HTTP请求头

- **Content-Type**: `application/json`
- **Accept**: `*/*`

[[回到顶部]](#) [[返回API列表]](../../README.md#api端点文档)
[[返回模型列表]](../../README.md#模型文档)
[[返回README]](../../README.md)

## `voiceClone()`

```php
voiceClone($voice_clone_param): \OpenAPI\Client\Model\ResponseOpenAPIVoiceCloneResult
```

元梦ai-语音克隆

语音克隆

### 示例

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');



$apiInstance = new OpenAPI\Client\Api\AiApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$voice_clone_param = new \OpenAPI\Client\Model\VoiceCloneParam(); // \OpenAPI\Client\Model\VoiceCloneParam

try {
    $result = $apiInstance->voiceClone($voice_clone_param);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling AiApi->voiceClone: ', $e->getMessage(), PHP_EOL;
}
```

### 参数

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **voice_clone_param** | [**\OpenAPI\Client\Model\VoiceCloneParam**](../Model/VoiceCloneParam.md)|  | [optional] |

### 返回类型

[**\OpenAPI\Client\Model\ResponseOpenAPIVoiceCloneResult**](../Model/ResponseOpenAPIVoiceCloneResult.md)

### HTTP请求头

- **Content-Type**: `application/json`
- **Accept**: `*/*`

[[回到顶部]](#) [[返回API列表]](../../README.md#api端点文档)
[[返回模型列表]](../../README.md#模型文档)
[[返回README]](../../README.md)
