<?php
/**
 * AiApi
 * PHP version 7.4
 *
 * @category Class
 * @package  OpenAPI\Client
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * 碳丝路数据开放平台API
 *
 * 碳丝路数据开放平台
 *
 * The version of the OpenAPI document: 0.4.8
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 7.0.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace OpenAPI\Client\Api;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\ConnectException;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use OpenAPI\Client\ApiClient;
use OpenAPI\Client\ApiException;
use OpenAPI\Client\Configuration;
use OpenAPI\Client\HeaderSelector;
use OpenAPI\Client\ObjectSerializer;

/**
 * AiApi Class Doc Comment
 *
 * @category Class
 * @package  OpenAPI\Client
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class AiApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @var HeaderSelector
     */
    protected $headerSelector;

    /**
     * @var int Host index
     */
    protected $hostIndex;

    /**
     * @var ApiClient api客户端
     */
    protected $apiClient;


    /** @var string[] $contentTypes **/
    public const contentTypes = [
        'chat' => [
            'application/json',
        ],
        'extractContent' => [
            'multipart/form-data',
        ],
        'speakerList' => [
            'application/json',
        ],
        'tokenCount' => [
            'application/json',
        ],
        'voiceClone' => [
            'application/json',
        ],
    ];

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     * @param int             $hostIndex (Optional) host index to select the list of hosts if defined in the OpenAPI spec
     */
    public function __construct(
        Configuration $config = null,
        ClientInterface $client = null,
        HeaderSelector $selector = null,
        $hostIndex = 0
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
        $this->hostIndex = $hostIndex;
        $this->apiClient = new ApiClient($config);
    }

    /**
     * Set the host index
     *
     * @param int $hostIndex Host index (required)
     */
    public function setHostIndex($hostIndex): void
    {
        $this->hostIndex = $hostIndex;
    }

    /**
     * Get the host index
     *
     * @return int Host index
     */
    public function getHostIndex()
    {
        return $this->hostIndex;
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation chat
     *
     * 元梦ai-对话
     *
     * @param  \OpenAPI\Client\Model\ChatParam $chat_param chat_param (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['chat'] to see the possible values for this operation
     *
     * @throws \OpenAPI\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \OpenAPI\Client\Model\ResponseOpenAPIChatResult
     */
    public function chat($chat_param = null, string $contentType = self::contentTypes['chat'][0])
    {
        list($response) = $this->chatWithHttpInfo($chat_param, $contentType);
        return $response;
    }

    /**
     * Operation chatWithHttpInfo
     *
     * 元梦ai-对话
     *
     * @param  \OpenAPI\Client\Model\ChatParam $chat_param (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['chat'] to see the possible values for this operation
     *
     * @throws \OpenAPI\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \OpenAPI\Client\Model\ResponseOpenAPIChatResult, HTTP status code, HTTP response headers (array of strings)
     */
    public function chatWithHttpInfo($chat_param = null, string $contentType = self::contentTypes['chat'][0])
    {
        $request = $this->chatRequest($chat_param, $contentType);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            // 响应预处理
            $data = json_decode($response->getBody(), true);
            if (json_last_error() !== JSON_ERROR_NONE) {
                throw new ApiException("JSON解码错误: " . json_last_error_msg());
            }

            // 验证签名
            if (!$this->apiClient->verifySign($data)) {
                throw new ApiException(
                    'Verification failed',
                    $response->getStatusCode(),
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            switch($statusCode) {
                case 200:
                    if ('\OpenAPI\Client\Model\ResponseOpenAPIChatResult' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\OpenAPI\Client\Model\ResponseOpenAPIChatResult' !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\OpenAPI\Client\Model\ResponseOpenAPIChatResult', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\OpenAPI\Client\Model\ResponseOpenAPIChatResult';
            if ($returnType === '\SplFileObject') {
                $content = $response->getBody(); //stream goes to serializer
            } else {
                $content = (string) $response->getBody();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\OpenAPI\Client\Model\ResponseOpenAPIChatResult',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation chatAsync
     *
     * 元梦ai-对话
     *
     * @param  \OpenAPI\Client\Model\ChatParam $chat_param (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['chat'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function chatAsync($chat_param = null, string $contentType = self::contentTypes['chat'][0])
    {
        return $this->chatAsyncWithHttpInfo($chat_param, $contentType)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation chatAsyncWithHttpInfo
     *
     * 元梦ai-对话
     *
     * @param  \OpenAPI\Client\Model\ChatParam $chat_param (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['chat'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function chatAsyncWithHttpInfo($chat_param = null, string $contentType = self::contentTypes['chat'][0])
    {
        $returnType = '\OpenAPI\Client\Model\ResponseOpenAPIChatResult';
        $request = $this->chatRequest($chat_param, $contentType);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    if ($returnType === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'chat'
     *
     * @param  \OpenAPI\Client\Model\ChatParam $chat_param (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['chat'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function chatRequest($chat_param = null, string $contentType = self::contentTypes['chat'][0])
    {



        $resourcePath = '/v1/ai/chat';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;





        $headers = $this->headerSelector->selectHeaders(
            ['*/*', ],
            $contentType,
            $multipart
        );

        // for model (json/xml)
        if (isset($chat_param)) {
            if (stripos($headers['Content-Type'], 'application/json') !== false) {
                # if Content-Type contains "application/json", json_encode the body
                $httpBody = \GuzzleHttp\Utils::jsonEncode(ObjectSerializer::sanitizeForSerialization($chat_param));
            } else {
                $httpBody = $chat_param;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif (stripos($headers['Content-Type'], 'application/json') !== false) {
                # if Content-Type contains "application/json", json_encode the form parameters
                $httpBody = \GuzzleHttp\Utils::jsonEncode($formParams);
            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }


        // 初始化额外的参数
        $additionalParams = [
            'payload' => json_decode($httpBody, true),
            'path' => $resourcePath,
            'charset' => $this->config->getCharset(),
            'time' => date($this->config->getDataFormat(), time()),
            'sign_type' => $this->config->getSignType(),
            'access_token' => '',
            'app_id' => $this->config->getAppid(),
            'sign' => ''
        ];

        $additionalParams['sign'] = $this->apiClient->requestSign($additionalParams);

        // 根据Content-Type决定如何合并额外的参数
        if (array_key_exists("Content-Type", $headers) && stripos($headers['Content-Type'], 'application/json') !== false) {
            // 如果是application/json，将额外的参数合并到现有的JSON对象中
            $existingParams = json_decode($httpBody, true);
            if ($existingParams === null) {
                $existingParams = [];
            }
            $mergedParams = array_merge($existingParams, $additionalParams);
            $httpBody = json_encode($mergedParams, JSON_UNESCAPED_SLASHES | JSON_UNESCAPED_UNICODE);
        } else if(array_key_exists("Content-Type", $headers)){
            // 如果不是application/json，将额外的参数合并到现有的查询字符串中
            $existingParams = [];
            if ($httpBody != null) {
                parse_str($httpBody, $existingParams);
            }
            $mergedParams = array_merge($existingParams, $additionalParams);
            $httpBody = ObjectSerializer::buildQuery($mergedParams);
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $operationHost = $this->config->getHost();
        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'POST',
            $operationHost . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation extractContent
     *
     * 元梦ai-提取上传文件的内容
     *
     * @param  \SplFileObject $file file (optional)
     * @param  \OpenAPI\Client\Model\ExtraContentParam $param param (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['extractContent'] to see the possible values for this operation
     *
     * @throws \OpenAPI\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \OpenAPI\Client\Model\ResponseOpenAPIExtractContentResult
     */
    public function extractContent($file = null, $param = null, string $contentType = self::contentTypes['extractContent'][0])
    {
        list($response) = $this->extractContentWithHttpInfo($file, $param, $contentType);
        return $response;
    }

    /**
     * Operation extractContentWithHttpInfo
     *
     * 元梦ai-提取上传文件的内容
     *
     * @param  \SplFileObject $file (optional)
     * @param  \OpenAPI\Client\Model\ExtraContentParam $param (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['extractContent'] to see the possible values for this operation
     *
     * @throws \OpenAPI\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \OpenAPI\Client\Model\ResponseOpenAPIExtractContentResult, HTTP status code, HTTP response headers (array of strings)
     */
    public function extractContentWithHttpInfo($file = null, $param = null, string $contentType = self::contentTypes['extractContent'][0])
    {
        $request = $this->extractContentRequest($file, $param, $contentType);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            // 响应预处理
            $data = json_decode($response->getBody(), true);
            if (json_last_error() !== JSON_ERROR_NONE) {
                throw new ApiException("JSON解码错误: " . json_last_error_msg());
            }

            // 验证签名
            if (!$this->apiClient->verifySign($data)) {
                throw new ApiException(
                    'Verification failed',
                    $response->getStatusCode(),
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            switch($statusCode) {
                case 200:
                    if ('\OpenAPI\Client\Model\ResponseOpenAPIExtractContentResult' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\OpenAPI\Client\Model\ResponseOpenAPIExtractContentResult' !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\OpenAPI\Client\Model\ResponseOpenAPIExtractContentResult', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\OpenAPI\Client\Model\ResponseOpenAPIExtractContentResult';
            if ($returnType === '\SplFileObject') {
                $content = $response->getBody(); //stream goes to serializer
            } else {
                $content = (string) $response->getBody();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\OpenAPI\Client\Model\ResponseOpenAPIExtractContentResult',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation extractContentAsync
     *
     * 元梦ai-提取上传文件的内容
     *
     * @param  \SplFileObject $file (optional)
     * @param  \OpenAPI\Client\Model\ExtraContentParam $param (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['extractContent'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function extractContentAsync($file = null, $param = null, string $contentType = self::contentTypes['extractContent'][0])
    {
        return $this->extractContentAsyncWithHttpInfo($file, $param, $contentType)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation extractContentAsyncWithHttpInfo
     *
     * 元梦ai-提取上传文件的内容
     *
     * @param  \SplFileObject $file (optional)
     * @param  \OpenAPI\Client\Model\ExtraContentParam $param (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['extractContent'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function extractContentAsyncWithHttpInfo($file = null, $param = null, string $contentType = self::contentTypes['extractContent'][0])
    {
        $returnType = '\OpenAPI\Client\Model\ResponseOpenAPIExtractContentResult';
        $request = $this->extractContentRequest($file, $param, $contentType);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    if ($returnType === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'extractContent'
     *
     * @param  \SplFileObject $file (optional)
     * @param  \OpenAPI\Client\Model\ExtraContentParam $param (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['extractContent'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function extractContentRequest($file = null, $param = null, string $contentType = self::contentTypes['extractContent'][0])
    {




        $resourcePath = '/v1/ai/extractContent';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;




        // form params
        if ($file !== null) {
            $multipart = true;
            $formParams['file'] = [];
            $paramFiles = is_array($file) ? $file : [$file];
            foreach ($paramFiles as $paramFile) {
                $formParams['file'][] = \GuzzleHttp\Psr7\Utils::tryFopen(
                    ObjectSerializer::toFormValue($paramFile),
                    'rb'
                );
            }
        }
        // form params
        if ($param !== null) {
            $formParams['param'] = ObjectSerializer::toFormValue($param);
        }

        $headers = $this->headerSelector->selectHeaders(
            ['*/*', ],
            $contentType,
            $multipart
        );

        // for model (json/xml)
        // 初始化额外的参数
        $additionalParams = [
            'payload' => json_decode($httpBody, true),
            'path' => $resourcePath,
            'charset' => $this->config->getCharset(),
            'time' => date($this->config->getDataFormat(), time()),
            'sign_type' => $this->config->getSignType(),
            'access_token' => '',
            'app_id' => $this->config->getAppid(),
            'sign' => ''
        ];

        $additionalParams['sign'] = $this->apiClient->requestSign($additionalParams);

        if (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                $multipartContents[] = [
                    'name' => 'sign_param',
                    'contents' => json_encode($additionalParams)
                ];
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif (stripos($headers['Content-Type'], 'application/json') !== false) {
                # if Content-Type contains "application/json", json_encode the form parameters
                $httpBody = \GuzzleHttp\Utils::jsonEncode($formParams);
            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }  else if (array_key_exists("Content-Type", $headers) &&
            stripos($headers['Content-Type'], 'application/json') !== false) {
            // 如果是application/json，将额外的参数合并到现有的JSON对象中
            $existingParams = json_decode($httpBody, true);
            if ($existingParams === null) {
                $existingParams = [];
            }
            $mergedParams = array_merge($existingParams, $additionalParams);
            $httpBody = json_encode($mergedParams, JSON_UNESCAPED_SLASHES | JSON_UNESCAPED_UNICODE);
        }




        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $operationHost = $this->config->getHost();
        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'POST',
            $operationHost . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation speakerList
     *
     * 元梦ai-获取发音人列表
     *
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['speakerList'] to see the possible values for this operation
     *
     * @throws \OpenAPI\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \OpenAPI\Client\Model\ResponseOpenAPISpeakerListResult
     */
    public function speakerList(string $contentType = self::contentTypes['speakerList'][0])
    {
        list($response) = $this->speakerListWithHttpInfo($contentType);
        return $response;
    }

    /**
     * Operation speakerListWithHttpInfo
     *
     * 元梦ai-获取发音人列表
     *
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['speakerList'] to see the possible values for this operation
     *
     * @throws \OpenAPI\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \OpenAPI\Client\Model\ResponseOpenAPISpeakerListResult, HTTP status code, HTTP response headers (array of strings)
     */
    public function speakerListWithHttpInfo(string $contentType = self::contentTypes['speakerList'][0])
    {
        $request = $this->speakerListRequest($contentType);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            // 响应预处理
            $data = json_decode($response->getBody(), true);
            if (json_last_error() !== JSON_ERROR_NONE) {
                throw new ApiException("JSON解码错误: " . json_last_error_msg());
            }

            // 验证签名
            if (!$this->apiClient->verifySign($data)) {
                throw new ApiException(
                    'Verification failed',
                    $response->getStatusCode(),
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            switch($statusCode) {
                case 200:
                    if ('\OpenAPI\Client\Model\ResponseOpenAPISpeakerListResult' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\OpenAPI\Client\Model\ResponseOpenAPISpeakerListResult' !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\OpenAPI\Client\Model\ResponseOpenAPISpeakerListResult', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\OpenAPI\Client\Model\ResponseOpenAPISpeakerListResult';
            if ($returnType === '\SplFileObject') {
                $content = $response->getBody(); //stream goes to serializer
            } else {
                $content = (string) $response->getBody();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\OpenAPI\Client\Model\ResponseOpenAPISpeakerListResult',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation speakerListAsync
     *
     * 元梦ai-获取发音人列表
     *
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['speakerList'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function speakerListAsync(string $contentType = self::contentTypes['speakerList'][0])
    {
        return $this->speakerListAsyncWithHttpInfo($contentType)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation speakerListAsyncWithHttpInfo
     *
     * 元梦ai-获取发音人列表
     *
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['speakerList'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function speakerListAsyncWithHttpInfo(string $contentType = self::contentTypes['speakerList'][0])
    {
        $returnType = '\OpenAPI\Client\Model\ResponseOpenAPISpeakerListResult';
        $request = $this->speakerListRequest($contentType);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    if ($returnType === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'speakerList'
     *
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['speakerList'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function speakerListRequest(string $contentType = self::contentTypes['speakerList'][0])
    {


        $resourcePath = '/v1/ai/speakerList';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;





        $headers = $this->headerSelector->selectHeaders(
            ['*/*', ],
            $contentType,
            $multipart
        );

        // for model (json/xml)
        // 初始化额外的参数
        $additionalParams = [
            'payload' => json_decode($httpBody, true),
            'path' => $resourcePath,
            'charset' => $this->config->getCharset(),
            'time' => date($this->config->getDataFormat(), time()),
            'sign_type' => $this->config->getSignType(),
            'access_token' => '',
            'app_id' => $this->config->getAppid(),
            'sign' => ''
        ];

        $additionalParams['sign'] = $this->apiClient->requestSign($additionalParams);

        if (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                $multipartContents[] = [
                    'name' => 'sign_param',
                    'contents' => json_encode($additionalParams)
                ];
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif (stripos($headers['Content-Type'], 'application/json') !== false) {
                # if Content-Type contains "application/json", json_encode the form parameters
                $httpBody = \GuzzleHttp\Utils::jsonEncode($formParams);
            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }  else if (array_key_exists("Content-Type", $headers) &&
            stripos($headers['Content-Type'], 'application/json') !== false) {
            // 如果是application/json，将额外的参数合并到现有的JSON对象中
            $existingParams = json_decode($httpBody, true);
            if ($existingParams === null) {
                $existingParams = [];
            }
            $mergedParams = array_merge($existingParams, $additionalParams);
            $httpBody = json_encode($mergedParams, JSON_UNESCAPED_SLASHES | JSON_UNESCAPED_UNICODE);
        }




        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $operationHost = $this->config->getHost();
        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'POST',
            $operationHost . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation tokenCount
     *
     * 元梦ai-token统计
     *
     * @param  \OpenAPI\Client\Model\TokenCountParam $token_count_param token_count_param (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['tokenCount'] to see the possible values for this operation
     *
     * @throws \OpenAPI\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \OpenAPI\Client\Model\ResponseOpenAPITokensCountResult
     */
    public function tokenCount($token_count_param = null, string $contentType = self::contentTypes['tokenCount'][0])
    {
        list($response) = $this->tokenCountWithHttpInfo($token_count_param, $contentType);
        return $response;
    }

    /**
     * Operation tokenCountWithHttpInfo
     *
     * 元梦ai-token统计
     *
     * @param  \OpenAPI\Client\Model\TokenCountParam $token_count_param (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['tokenCount'] to see the possible values for this operation
     *
     * @throws \OpenAPI\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \OpenAPI\Client\Model\ResponseOpenAPITokensCountResult, HTTP status code, HTTP response headers (array of strings)
     */
    public function tokenCountWithHttpInfo($token_count_param = null, string $contentType = self::contentTypes['tokenCount'][0])
    {
        $request = $this->tokenCountRequest($token_count_param, $contentType);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            // 响应预处理
            $data = json_decode($response->getBody(), true);
            if (json_last_error() !== JSON_ERROR_NONE) {
                throw new ApiException("JSON解码错误: " . json_last_error_msg());
            }

            // 验证签名
            if (!$this->apiClient->verifySign($data)) {
                throw new ApiException(
                    'Verification failed',
                    $response->getStatusCode(),
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            switch($statusCode) {
                case 200:
                    if ('\OpenAPI\Client\Model\ResponseOpenAPITokensCountResult' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\OpenAPI\Client\Model\ResponseOpenAPITokensCountResult' !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\OpenAPI\Client\Model\ResponseOpenAPITokensCountResult', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\OpenAPI\Client\Model\ResponseOpenAPITokensCountResult';
            if ($returnType === '\SplFileObject') {
                $content = $response->getBody(); //stream goes to serializer
            } else {
                $content = (string) $response->getBody();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\OpenAPI\Client\Model\ResponseOpenAPITokensCountResult',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation tokenCountAsync
     *
     * 元梦ai-token统计
     *
     * @param  \OpenAPI\Client\Model\TokenCountParam $token_count_param (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['tokenCount'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function tokenCountAsync($token_count_param = null, string $contentType = self::contentTypes['tokenCount'][0])
    {
        return $this->tokenCountAsyncWithHttpInfo($token_count_param, $contentType)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation tokenCountAsyncWithHttpInfo
     *
     * 元梦ai-token统计
     *
     * @param  \OpenAPI\Client\Model\TokenCountParam $token_count_param (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['tokenCount'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function tokenCountAsyncWithHttpInfo($token_count_param = null, string $contentType = self::contentTypes['tokenCount'][0])
    {
        $returnType = '\OpenAPI\Client\Model\ResponseOpenAPITokensCountResult';
        $request = $this->tokenCountRequest($token_count_param, $contentType);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    if ($returnType === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'tokenCount'
     *
     * @param  \OpenAPI\Client\Model\TokenCountParam $token_count_param (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['tokenCount'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function tokenCountRequest($token_count_param = null, string $contentType = self::contentTypes['tokenCount'][0])
    {



        $resourcePath = '/v1/ai/tokenCount';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;





        $headers = $this->headerSelector->selectHeaders(
            ['*/*', ],
            $contentType,
            $multipart
        );

        // for model (json/xml)
        if (isset($token_count_param)) {
            if (stripos($headers['Content-Type'], 'application/json') !== false) {
                # if Content-Type contains "application/json", json_encode the body
                $httpBody = \GuzzleHttp\Utils::jsonEncode(ObjectSerializer::sanitizeForSerialization($token_count_param));
            } else {
                $httpBody = $token_count_param;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif (stripos($headers['Content-Type'], 'application/json') !== false) {
                # if Content-Type contains "application/json", json_encode the form parameters
                $httpBody = \GuzzleHttp\Utils::jsonEncode($formParams);
            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }


        // 初始化额外的参数
        $additionalParams = [
            'payload' => json_decode($httpBody, true),
            'path' => $resourcePath,
            'charset' => $this->config->getCharset(),
            'time' => date($this->config->getDataFormat(), time()),
            'sign_type' => $this->config->getSignType(),
            'access_token' => '',
            'app_id' => $this->config->getAppid(),
            'sign' => ''
        ];

        $additionalParams['sign'] = $this->apiClient->requestSign($additionalParams);

        // 根据Content-Type决定如何合并额外的参数
        if (array_key_exists("Content-Type", $headers) && stripos($headers['Content-Type'], 'application/json') !== false) {
            // 如果是application/json，将额外的参数合并到现有的JSON对象中
            $existingParams = json_decode($httpBody, true);
            if ($existingParams === null) {
                $existingParams = [];
            }
            $mergedParams = array_merge($existingParams, $additionalParams);
            $httpBody = json_encode($mergedParams, JSON_UNESCAPED_SLASHES | JSON_UNESCAPED_UNICODE);
        } else if(array_key_exists("Content-Type", $headers)){
            // 如果不是application/json，将额外的参数合并到现有的查询字符串中
            $existingParams = [];
            if ($httpBody != null) {
                parse_str($httpBody, $existingParams);
            }
            $mergedParams = array_merge($existingParams, $additionalParams);
            $httpBody = ObjectSerializer::buildQuery($mergedParams);
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $operationHost = $this->config->getHost();
        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'POST',
            $operationHost . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation voiceClone
     *
     * 元梦ai-语音克隆
     *
     * @param  \OpenAPI\Client\Model\VoiceCloneParam $voice_clone_param voice_clone_param (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['voiceClone'] to see the possible values for this operation
     *
     * @throws \OpenAPI\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \OpenAPI\Client\Model\ResponseOpenAPIVoiceCloneResult
     */
    public function voiceClone($voice_clone_param = null, string $contentType = self::contentTypes['voiceClone'][0])
    {
        list($response) = $this->voiceCloneWithHttpInfo($voice_clone_param, $contentType);
        return $response;
    }

    /**
     * Operation voiceCloneWithHttpInfo
     *
     * 元梦ai-语音克隆
     *
     * @param  \OpenAPI\Client\Model\VoiceCloneParam $voice_clone_param (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['voiceClone'] to see the possible values for this operation
     *
     * @throws \OpenAPI\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \OpenAPI\Client\Model\ResponseOpenAPIVoiceCloneResult, HTTP status code, HTTP response headers (array of strings)
     */
    public function voiceCloneWithHttpInfo($voice_clone_param = null, string $contentType = self::contentTypes['voiceClone'][0])
    {
        $request = $this->voiceCloneRequest($voice_clone_param, $contentType);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            // 响应预处理
            $data = json_decode($response->getBody(), true);
            if (json_last_error() !== JSON_ERROR_NONE) {
                throw new ApiException("JSON解码错误: " . json_last_error_msg());
            }

            // 验证签名
            if (!$this->apiClient->verifySign($data)) {
                throw new ApiException(
                    'Verification failed',
                    $response->getStatusCode(),
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            switch($statusCode) {
                case 200:
                    if ('\OpenAPI\Client\Model\ResponseOpenAPIVoiceCloneResult' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\OpenAPI\Client\Model\ResponseOpenAPIVoiceCloneResult' !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\OpenAPI\Client\Model\ResponseOpenAPIVoiceCloneResult', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\OpenAPI\Client\Model\ResponseOpenAPIVoiceCloneResult';
            if ($returnType === '\SplFileObject') {
                $content = $response->getBody(); //stream goes to serializer
            } else {
                $content = (string) $response->getBody();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\OpenAPI\Client\Model\ResponseOpenAPIVoiceCloneResult',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation voiceCloneAsync
     *
     * 元梦ai-语音克隆
     *
     * @param  \OpenAPI\Client\Model\VoiceCloneParam $voice_clone_param (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['voiceClone'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function voiceCloneAsync($voice_clone_param = null, string $contentType = self::contentTypes['voiceClone'][0])
    {
        return $this->voiceCloneAsyncWithHttpInfo($voice_clone_param, $contentType)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation voiceCloneAsyncWithHttpInfo
     *
     * 元梦ai-语音克隆
     *
     * @param  \OpenAPI\Client\Model\VoiceCloneParam $voice_clone_param (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['voiceClone'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function voiceCloneAsyncWithHttpInfo($voice_clone_param = null, string $contentType = self::contentTypes['voiceClone'][0])
    {
        $returnType = '\OpenAPI\Client\Model\ResponseOpenAPIVoiceCloneResult';
        $request = $this->voiceCloneRequest($voice_clone_param, $contentType);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    if ($returnType === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'voiceClone'
     *
     * @param  \OpenAPI\Client\Model\VoiceCloneParam $voice_clone_param (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['voiceClone'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function voiceCloneRequest($voice_clone_param = null, string $contentType = self::contentTypes['voiceClone'][0])
    {



        $resourcePath = '/v1/ai/voiceClone';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;





        $headers = $this->headerSelector->selectHeaders(
            ['*/*', ],
            $contentType,
            $multipart
        );

        // for model (json/xml)
        if (isset($voice_clone_param)) {
            if (stripos($headers['Content-Type'], 'application/json') !== false) {
                # if Content-Type contains "application/json", json_encode the body
                $httpBody = \GuzzleHttp\Utils::jsonEncode(ObjectSerializer::sanitizeForSerialization($voice_clone_param));
            } else {
                $httpBody = $voice_clone_param;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif (stripos($headers['Content-Type'], 'application/json') !== false) {
                # if Content-Type contains "application/json", json_encode the form parameters
                $httpBody = \GuzzleHttp\Utils::jsonEncode($formParams);
            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }


        // 初始化额外的参数
        $additionalParams = [
            'payload' => json_decode($httpBody, true),
            'path' => $resourcePath,
            'charset' => $this->config->getCharset(),
            'time' => date($this->config->getDataFormat(), time()),
            'sign_type' => $this->config->getSignType(),
            'access_token' => '',
            'app_id' => $this->config->getAppid(),
            'sign' => ''
        ];

        $additionalParams['sign'] = $this->apiClient->requestSign($additionalParams);

        // 根据Content-Type决定如何合并额外的参数
        if (array_key_exists("Content-Type", $headers) && stripos($headers['Content-Type'], 'application/json') !== false) {
            // 如果是application/json，将额外的参数合并到现有的JSON对象中
            $existingParams = json_decode($httpBody, true);
            if ($existingParams === null) {
                $existingParams = [];
            }
            $mergedParams = array_merge($existingParams, $additionalParams);
            $httpBody = json_encode($mergedParams, JSON_UNESCAPED_SLASHES | JSON_UNESCAPED_UNICODE);
        } else if(array_key_exists("Content-Type", $headers)){
            // 如果不是application/json，将额外的参数合并到现有的查询字符串中
            $existingParams = [];
            if ($httpBody != null) {
                parse_str($httpBody, $existingParams);
            }
            $mergedParams = array_merge($existingParams, $additionalParams);
            $httpBody = ObjectSerializer::buildQuery($mergedParams);
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $operationHost = $this->config->getHost();
        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'POST',
            $operationHost . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
